// Code generated by protoc-gen-go-aeus. DO NOT EDIT.
// source: organize.proto
// date: 2025-06-22 11:09:05

package pb

import (
	"git.nobla.cn/golang/aeus/transport/http"
	"context"
	"git.nobla.cn/golang/aeus/pkg/errors"
)

type UserServiceHttpServer interface {

	// 获取用户菜单
	GetMenus(ctx context.Context, req *GetUserMenuRequest) (res *GetUserMenuResponse, err error)

	// 获取用户信息
	GetProfile(ctx context.Context, req *GetProfileRequest) (res *GetProfileResponse, err error)

	// 更新用户信息
	UpdateProfile(ctx context.Context, req *UpdateProfileRequest) (res *UpdateProfileResponse, err error)

	// 重置用户密码
	ResetPassword(ctx context.Context, req *ResetPasswordRequest) (res *ResetPasswordResponse, err error)

	// 获取用户权限
	GetPermissions(ctx context.Context, req *GetPermissionRequest) (res *GetPermissionResponse, err error)

	// 获取用户标签
	GetUserLabels(ctx context.Context, req *GetUserLabelRequest) (res *GetUserLabelResponse, err error)

	// 获取用户标签
	GetUserTags(ctx context.Context, req *GetUserTagRequest) (res *GetUserTagResponse, err error)
}

type DepartmentServiceHttpServer interface {

	// 获取部门标签
	GetDepartmentLabels(ctx context.Context, req *GetDepartmentLabelRequest) (res *GetDepartmentLabelResponse, err error)

	GetDepartmentUsers(ctx context.Context, req *GetDepartmentUserRequest) (res *GetDepartmentUserResponse, err error)

	GetDepartmentLevelLabels(ctx context.Context, req *GetDepartmentLevelLabelsRequest) (res *GetDepartmentLevelLabelsResponse, err error)
}

type RoleServiceHttpServer interface {

	// 获取角色标签
	GetRoleLabels(ctx context.Context, req *GetRoleLabelRequest) (res *GetRoleLabelResponse, err error)

	// 获取角色权限
	GetRolePermissions(ctx context.Context, req *GetRolePermissionRequest) (res *GetRolePermissionResponse, err error)

	SaveRolePermission(ctx context.Context, req *SaveRolePermissionRequest) (res *SaveRolePermissionResponse, err error)
}

type MenuServiceHttpServer interface {
	GetMenus(ctx context.Context, req *GetMenuRequest) (res *GetMenuResponse, err error)

	GetMenuLevelLabels(ctx context.Context, req *GetMenuLevelLabelsRequest) (res *GetMenuLevelLabelsResponse, err error)
}

type AuthServiceHttpServer interface {
	Login(ctx context.Context, req *LoginRequest) (res *LoginResponse, err error)

	Logout(ctx context.Context, req *LogoutRequest) (res *LogoutResponse, err error)
}

// 获取用户菜单
func handleUserServiceGetMenus(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetUserMenuRequest{}
		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}
		if res, err := s.GetMenus(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取用户信息
func handleUserServiceGetProfile(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetProfileRequest{}
		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}
		if res, err := s.GetProfile(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 更新用户信息
func handleUserServiceUpdateProfile(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &UpdateProfileRequest{}
		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}
		if res, err := s.UpdateProfile(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 重置用户密码
func handleUserServiceResetPassword(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &ResetPasswordRequest{}
		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}
		if res, err := s.ResetPassword(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取用户权限
func handleUserServiceGetPermissions(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetPermissionRequest{}
		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}
		if res, err := s.GetPermissions(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取用户标签
func handleUserServiceGetUserLabels(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetUserLabelRequest{}

		if res, err := s.GetUserLabels(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取用户标签
func handleUserServiceGetUserTags(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetUserTagRequest{}

		if res, err := s.GetUserTags(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取部门标签
func handleDepartmentServiceGetDepartmentLabels(s DepartmentServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetDepartmentLabelRequest{}

		if res, err := s.GetDepartmentLabels(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

func handleDepartmentServiceGetDepartmentUsers(s DepartmentServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetDepartmentUserRequest{}

		if res, err := s.GetDepartmentUsers(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

func handleDepartmentServiceGetDepartmentLevelLabels(s DepartmentServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetDepartmentLevelLabelsRequest{}

		if res, err := s.GetDepartmentLevelLabels(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取角色标签
func handleRoleServiceGetRoleLabels(s RoleServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetRoleLabelRequest{}

		if res, err := s.GetRoleLabels(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取角色权限
func handleRoleServiceGetRolePermissions(s RoleServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetRolePermissionRequest{}
		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}
		if res, err := s.GetRolePermissions(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

func handleRoleServiceSaveRolePermission(s RoleServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &SaveRolePermissionRequest{}
		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}
		if res, err := s.SaveRolePermission(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

func handleMenuServiceGetMenus(s MenuServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetMenuRequest{}

		if res, err := s.GetMenus(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

func handleMenuServiceGetMenuLevelLabels(s MenuServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetMenuLevelLabelsRequest{}

		if res, err := s.GetMenuLevelLabels(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

func handleAuthServiceLogin(s AuthServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &LoginRequest{}
		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}
		if res, err := s.Login(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

func handleAuthServiceLogout(s AuthServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &LogoutRequest{}
		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}
		if res, err := s.Logout(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

func RegisterUserServiceRouter(hs *http.Server, s UserServiceHttpServer) {

	// Register handle GetMenus route
	hs.GET("/user/menus", handleUserServiceGetMenus(s))

	// Register handle GetProfile route
	hs.GET("/user/profile", handleUserServiceGetProfile(s))

	// Register handle UpdateProfile route
	hs.PUT("/user/profile", handleUserServiceUpdateProfile(s))

	// Register handle ResetPassword route
	hs.POST("/user/reset-password", handleUserServiceResetPassword(s))

	// Register handle GetPermissions route
	hs.GET("/user/permissions", handleUserServiceGetPermissions(s))

	// Register handle GetUserLabels route
	hs.GET("/user/labels", handleUserServiceGetUserLabels(s))

	// Register handle GetUserTags route
	hs.GET("/user/tags", handleUserServiceGetUserTags(s))

}

func RegisterDepartmentServiceRouter(hs *http.Server, s DepartmentServiceHttpServer) {

	// Register handle GetDepartmentLabels route
	hs.GET("/department/labels", handleDepartmentServiceGetDepartmentLabels(s))

	// Register handle GetDepartmentUsers route
	hs.GET("/department/users", handleDepartmentServiceGetDepartmentUsers(s))

	// Register handle GetDepartmentLevelLabels route
	hs.GET("/department/level-labels", handleDepartmentServiceGetDepartmentLevelLabels(s))

}

func RegisterRoleServiceRouter(hs *http.Server, s RoleServiceHttpServer) {

	// Register handle GetRoleLabels route
	hs.GET("/role/labels", handleRoleServiceGetRoleLabels(s))

	// Register handle GetRolePermissions route
	hs.GET("/role/permissions", handleRoleServiceGetRolePermissions(s))

	// Register handle SaveRolePermission route
	hs.POST("/role/permissions", handleRoleServiceSaveRolePermission(s))

}

func RegisterMenuServiceRouter(hs *http.Server, s MenuServiceHttpServer) {

	// Register handle GetMenus route
	hs.GET("/menu/list", handleMenuServiceGetMenus(s))

	// Register handle GetMenuLevelLabels route
	hs.GET("/menu/level-labels", handleMenuServiceGetMenuLevelLabels(s))

}

func RegisterAuthServiceRouter(hs *http.Server, s AuthServiceHttpServer) {

	// Register handle Login route
	hs.POST("/passport/login", handleAuthServiceLogin(s))

	// Register handle Logout route
	hs.POST("/passport/logout", handleAuthServiceLogout(s))

}
